import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.*;
public class Actor3 extends Actor
{
    private boolean isTransparent = false;
    
    public void addedToWorld(World w)
    {
        setImage(new GreenfootImage("ActorImage1" + Greenfoot.getRandomNumber(4) + ".PNG"));
    }

    public void act() 
    {
        if(Greenfoot.mousePressed(this) && !isTransparent)
        {
            turnTransparent3();
            isTransparent = true;
        }
    }
    
    /**
     * This method method finds the background
     * color and removes it from the actor's image.
     */
    private void turnTransparent3()
    {
        GreenfootImage img = getImage();
        Color transparent = new Color(0, 0, 0, 0);
        List<Color> colors = new ArrayList<Color>();
        List<Integer> frequencys = new ArrayList<Integer>();
        for(int x = 0; x < img.getWidth(); x++)
        {
            for(int y = 0; y < img.getHeight(); y++)
            {
                Color thisColor = img.getColorAt(x, y);
                int matchPos = colors.indexOf(thisColor);
                if(matchPos != -1)
                {
                    frequencys.set(matchPos, frequencys.get(matchPos) + 1);
                }
                else
                {
                    colors.add(thisColor);
                    frequencys.add(1);
                }
            }
        }
        int maxFreq = 0,
            maxPos = 0;
        for(int i = 0; i < frequencys.size(); i++)
        {
            if(frequencys.get(i) > maxFreq)
            {
                maxFreq = frequencys.get(i);
                maxPos = i;
            }
        }
        Color bgColor = colors.get(maxPos);
        for(int x = 0; x < img.getWidth(); x++)
            for(int y = 0; y < img.getHeight(); y++)
                if(img.getColorAt(x, y).equals(bgColor))
                    img.setColorAt(x, y, transparent);
    }
}
